.build: &build_common
  before_script:
    - mkdir -p src_tmp/${CI_PROJECT_NAME} && mv `find -maxdepth 1 -not -name . -not -name src_tmp` src_tmp/${CI_PROJECT_NAME} && mv src_tmp/ src/
    - sudo apt-get update
    - sudo apt-get install -y wget python3-pip python3-setuptools python3-colcon-common-extensions
    - pip3 install setuptools==45.2.0
    - rosdep update
  script:
    - source /opt/ros/${ROS_DISTRO}/setup.bash
    - rosdep install -y --from-paths src --ignore-src --rosdistro ${ROS_DISTRO}
    # We first build the entire workspace normally
    - colcon build --cmake-args -DCMAKE_CXX_FLAGS="${CMAKE_CXX_FLAGS} -fprofile-arcs -ftest-coverage" -DCMAKE_C_FLAGS="${CMAKE_C_FLAGS} -fprofile-arcs -ftest-coverage" -DCMAKE_BUILD_TYPE=Debug
    # And then build the tests target. catkin (ROS1) packages add their tests to the tests target
    # which is not the standard target for CMake projects. We need to trigger the tests target so that
    # tests are built and any fixtures are set up.
    - colcon build --cmake-target tests --cmake-args -DCMAKE_CXX_FLAGS="${CMAKE_CXX_FLAGS} -fprofile-arcs -ftest-coverage" -DCMAKE_C_FLAGS="${CMAKE_C_FLAGS} -fprofile-arcs -ftest-coverage" -DCMAKE_BUILD_TYPE=Debug
    - colcon test
    - colcon test-result --verbose

ros_build:
  image: autonomoustuff/autoware:bleedingedge-noetic-base
  <<: *build_common
  only:
    - merge_requests
    - as/master
